#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_ShellCFG.h"
std::auto_ptr<Fish_ShellCFG> Fish_ShellCFG::msSingleton(nullptr);

int Fish_ShellCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_ShellCFGData* Fish_ShellCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_ShellCFGData>& Fish_ShellCFG::GetMapData()
{
	return mMapData;
}

void Fish_ShellCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_ShellCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_ShellCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mShellrate = element->IntAttribute("Shellrate");
		data.mWeight = element->IntAttribute("Weight");
		{
			const char* ShellItem = element->Attribute("ShellItem");
			std::vector<std::string> vecShellItem;
			boost::split(vecShellItem, ShellItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecShellItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecShellItem[i].c_str(), &temp))
				{
					data.mShellItem.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_ShellCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ShellCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_ShellCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_ShellCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_ShellCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Shellrate", data.mShellrate);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		LuaCfgHelper::readVectorInt(L, "ShellItem", data.mShellItem);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_ShellCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ShellCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_ShellCFG* Fish_ShellCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_ShellCFG());
	}
	return msSingleton.get();
}

void Fish_ShellCFG::Release()
{
	msSingleton.reset(nullptr);
}
